/***
 * Excerpted from "Groovy Recipes",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/sdgrvr for more book information.
***/
/*
class Get{
	String url
	String queryString
	String text
	
	String getText(){
		def thisUrl = new URL(url + "?" + queryString)
		return thisUrl.text		
	}	
}
*/

class Get{
  String url
  String queryString
  URLConnection connection
  String text
  
  String getText(){
    def thisUrl = new URL(this.toString())
    connection = thisUrl.openConnection()
    if(connection.responseCode == 200){
      return connection.content.text
    }
    else{
      return "Something bad happened\n" + 
        "URL: " + this.toString() + "\n" + 
        connection.responseCode + ": " +
        connection.responseMessage
    }
  }	

  String toString(){
    return url + "?" + queryString
  }
}

def get = new Get(url:"http://search.yahoo.com/search")
get.queryString = "p=groovy"
println get
//===> http://search.yahoo.com/search?p=groovy

//println get.text
//===> <html><head>...

get.url= "http://www.yahoo.com/no.such.page"
println get.text
/*
Something bad happened
URL: http://www.yahoo.com/no.such.page?p=groovy
404: Not Found
*/

