/***
 * Excerpted from "Groovy Recipes",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/sdgrvr for more book information.
***/
class QueryString{
	Map params = [:] 
	
	//this constructor allows you to pass in a Map
	QueryString(Map params){
		if(params){
			this.params.putAll(params)			
		}
	}

    //this method allows you to add name/value pairs
	void add(String name, Object value){
		params.put(name, value)
	}
	
	//this method returns a well-formed QueryString
	String toString(){
	  def list = []
	  params.each{name,value->
	    list << "$name=" + URLEncoder.encode(value.toString())
	  }
	  return list.join("&")		
	}
}


class Get{
  String url
  QueryString queryString = new QueryString()
  URLConnection connection
  String text

  String getText(){
    def thisUrl = new URL(this.toString())
    connection = thisUrl.openConnection()
    if(connection.responseCode == 200){
      return connection.content.text
    }
    else{
      return "Something bad happened\n" + 
        "URL: " + this.toString() + "\n" + 
        connection.responseCode + ": " +
        connection.responseMessage
    }
  }	
  
  String toString(){
    return url + "?" + queryString.toString()
  }
}

def get = new Get(url:"http://search.yahoo.com/search")
get.queryString.add("n", 20)
get.queryString.add("vf", "pdf")
get.queryString.add("p", "groovy grails") 

println get
//===> http://search.yahoo.com/search?n=20&vf=pdf&p=groovy+grails

//println get.text