/***
 * Excerpted from "Groovy Recipes",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/sdgrvr for more book information.
***/
class Greeting{
  def sayHello(){
    println "Hello Stranger"
  }

  def sayHello(String name){
    println "Hello ${name}"
  }

  def sayHello(String name, String other){
    println "Hello ${name} and ${other}"
  }
}

def g = new Greeting()
if(g.metaClass.respondsTo(g, "sayHello", null)){
	g.sayHello()
}
//===> Hello Stranger 

println "--- no arg"
println g.metaClass.respondsTo(g, "sayHello", null)
println g.metaClass.respondsTo(g, "sayHello", null).size()
println "--- one arg"
println g.metaClass.respondsTo(g, "sayHello", String)

if(g.metaClass.respondsTo(g, "sayHello", String)){
  g.sayHello("Scott")	
}
//===> Hello Scott

if(g.metaClass.respondsTo(g, "sayHello", String, String)){
  g.sayHello("Scott", "Bubba")	
}
//===> Hello Scott and Bubba



println "Number of sayHello() methods: " + 
  g.metaClass.respondsTo(g, "sayHello").size()
//===> Number of sayHello() methods: 2

g.metaClass.respondsTo(g, "sayHello").each{m ->
  println "${m.name} ${m.nativeParameterTypes}"
}
//===>
//sayHello {class java.lang.String}
//sayHello {}


