/***
 * Excerpted from "Groovy Recipes",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/sdgrvr for more book information.
***/
class QueryString{
	Map params = [:] 
	
	//this constructor allows you to pass in a Map
	QueryString(Map params){
		if(params){
			this.params.putAll(params)			
		}
	}

    //this method allows you to add name/value pairs
	void add(String name, Object value){
		params.put(name, value)
	}
	
	//this method returns a well-formed QueryString
	String toString(){
	  def list = []
	  params.each{name,value->
	    list << "$name=" + URLEncoder.encode(value.toString())
	  }
	  return list.join("&")		
	}
}



def map = [dad:"Scott", mom:"Kim", kid:"Billy Bob"]
def qs = new QueryString(map)
println qs
//===> dad=Scott&mom=Kim&kid=Billy+Bob

def qs2 = new QueryString()
qs2.params.put("firstname", "Scott")
qs2.add("id", 99)
qs2.add "updated", new Date()
println qs2
//===> firstname=Scott&id=99&updated=Wed+Oct+10+20%3A17%3A34+MDT+2007

//def map = [n:20, vf:"pdf", p:"groovy grails"]
def qs3 = new QueryString(n:20, vf:"pdf", p:"groovy grails")
println qs3
//===> n=20&vf=pdf&p=groovy+grails


