/***
 * Excerpted from "Groovy Recipes",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/sdgrvr for more book information.
***/
//curl --request POST --data @req.xml http://geocoder.us/service/xmlrpc

def address = "1600 Pennsylvania Av, Washington, DC"
def xmlrpcRequest = """<methodCall>
  <methodName>geocode</methodName>
  <params>
    <param>
        <value><string>${address}</string></value>
    </param>
  </params>
</methodCall>"""
def xmlrpcUrl = new URL("http://geocoder.us/service/xmlrpc")
def connection = xmlrpcUrl.openConnection() 
connection.setRequestMethod("POST") 
connection.setRequestProperty("Content-Type","application/xml") 
connection.doOutput = true 
Writer writer = new OutputStreamWriter(connection.outputStream) 
writer.write(xmlrpcRequest) 
writer.flush() 
writer.close() 
connection.connect() 

def xmlrpcResponse = connection.content.text 

//println xmlrpcResponse

xmlrpcResponse = """<?xml version="1.0" encoding="UTF-8"?>
<methodResponse><params><param><value><array><data><value><struct>
<member><name>number</name><value><int>1600</int></value></member>
<member><name>lat</name><value><double>38.898748</double></value></member>
<member><name>street</name><value><string>Pennsylvania</string></value></member>
<member><name>state</name><value><string>DC</string></value></member>
<member><name>city</name><value><string>Washington</string></value></member>
<member><name>zip</name><value><int>20502</int></value></member>
<member><name>suffix</name><value><string>NW</string></value></member>
<member><name>long</name><value><double>-77.037684</double></value></member>
<member><name>type</name><value><string>Ave</string></value></member>
<member><name>prefix</name><value><string/></value></member>
</struct></value></data></array></value></param></params></methodResponse>"""

def methodResponse = new XmlSlurper().parseText(xmlrpcResponse) 
methodResponse.params.param.value.array.data.value.struct.member.each{member ->
  if(member.name == "lat" || member.name == "long"){
    println "${member.name}: ${member.value.double}"
  }
}

