/***
 * Excerpted from "Groovy Recipes",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/sdgrvr for more book information.
***/
/*def url = new URL("http://www.google.com")
println "\n\neach line:"
url.eachLine{line -> println line}
println "\n\nwhole thing:"
println url.text*/

def partialRestRequest = "http://geocoder.us/service/rest/geocode?address="
def address = "1600 Pennsylvania Ave, Washington DC"

//def restRequest = "http://geocoder.us/service/rest/geocode?address=1600+Pennsylvania+Ave,+Washington+DC"
def restRequest = partialRestRequest + URLEncoder.encode(address)
def restUrl = new URL(restRequest)
//println restUrl
def restResponse = restUrl.text
//restUrl.eachLine{line -> println line}
/*
<rdf:RDF
  xmlns:dc="http://purl.org/dc/elements/1.1/"
  xmlns:geo="http://www.w3.org/2003/01/geo/wgs84_pos#"
  xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
  <geo:Point rdf:nodeID="aid76408515">  
    <dc:description>1600 Pennsylvania Ave NW, Washington DC 20502</dc:description>
    <geo:long>-77.037684</geo:long>
    <geo:lat>38.898748</geo:lat>
  </geo:Point>
</rdf:RDF>

*/

def RDF = new XmlSlurper().parseText(restResponse)
println RDF.Point.description
println RDF.Point.long
println RDF.Point.lat












// #################### CSV
def partialCsvRequest = "http://geocoder.us/service/csv/geocode?address="
def csvRequest = partialCsvRequest + URLEncoder.encode(address)
def csvUrl = new URL(csvRequest)
def csvResponse = csvUrl.text
//println csvResponse
//38.898748,-77.037684,1600 Pennsylvania Ave NW,Washington,DC,20502

def tokens = csvResponse.split(",")
//tokens.each{println it}
println "Latitude:  [${tokens[0]}]"
println "Longitude: [${tokens[1]}]"
println "Address:   [${tokens[2]}]"
println "City:      [${tokens[3]}]"
println "State:     [${tokens[4]}]"
println "Zip:       [${tokens[5]}]"
/*
Latitude:  [38.898748]
Longitude: [-77.037684]
Address:   [1600 Pennsylvania Ave NW]
City:      [Washington]
State:     [DC]
Zip:       [20502

*/











// #################### XML-RPC
def partialXmlRpcRequest = "http://geocoder.us/service/xmlrpc"



//curl --request POST --data @req.xml http://geocoder.us/service/xmlrpc



/*

<methodCall>
  <methodName>geocode</methodName>
  <params>
    <param>
        <value><string>1600 Pennsylvania Av, Washington, DC</string></value>
    </param>
  </params>
</methodCall>
*/

















// #################### SOAP
//http://geocoder.us/dist/eg/clients/GeoCoder.wsdl
//geocoder is free for non-commercial use
//for commercial use, see  http://geocoder.us/user/signup
//curl --request POST --data @soap.xml http://geocoder.us/service/soap



