/***
 * Excerpted from "Groovy Recipes",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/sdgrvr for more book information.
***/
def hi = { println "Hi"}
hi()
println "============="
println hi.getClass()



hi.run()
hi.call()

def hello = { println "Hello ${it}" }
hello("Scott")
hello "Scott"

def names = ["Chris", "Libby"]
names.each{n -> hello n }

def convertToCelsius = {
	return (5.0/9.0) * (it.toFloat() - 32.0)
}

[0, 32, 70, 100].each{ println "${it} farenheit in celsius: ${convertToCelsius(it)}" }



/*
0 farenheit in celsius: -17.7777777792
32 farenheit in celsius: 0.0
70 farenheit in celsius: 21.1111111128
100 farenheit in celsius: 37.7777777808
*/

def calculateTax = { taxRate, amount ->
	return amount + (taxRate * amount)
}
println "Total cost: ${calculateTax(0.055, 100)}"
//Total cost: 105.500

def tax = calculateTax.curry(0.1)
[10,20,30].each{
	println "Total cost: ${tax(it)}"
}

/*
Total cost: 11.0
Total cost: 22.0
Total cost: 33.0
*/
