/***
 * Excerpted from "Groovy Recipes",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/sdgrvr for more book information.
***/
public class Mocking extends GroovyTestCase
{
	Mocking _obj

	public void setUp()
	{
		_obj = new Mocking()
	}

	public void writeInfo()
	{
		//...
		def file = new File("output.dat")
		file.write("some info...")
		//...
	}



	public void testWithMock()
	{
		def fileMock = new groovy.mock.interceptor.StubFor(java.io.File)

		def msg = ""
		fileMock.demand.write { txt -> msg = txt }
		fileMock.demand.close { }

		fileMock.use
		{
		  _obj.writeInfo()
		}

		assertEquals("some info...", msg)
	}		



	public void testWithMockFor()
	{
		def fileMock = new groovy.mock.interceptor.MockFor(java.io.File)

		def msg = ""
		fileMock.demand.write { txt -> msg = txt }
		fileMock.demand.close { }

		fileMock.use
		{
		  _obj.writeInfo()
		}

		assertEquals("some info...", msg)
	}		

}
