/***
 * Excerpted from "Groovy Recipes",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/sdgrvr for more book information.
***/
def fileIn = new File("addresses2.csv")
def fileOut = new FileWriter("addresses2.xml")
def xml = new groovy.xml.MarkupBuilder(fileOut)
//def xml = new groovy.xml.MarkupBuilder()
xml.addressBook{
	use(SmartCsvParser){
	   fileIn.eachLine{ line ->
		  def fields = line.smartSplit()
	      entry(id:fields[0]){
	        name(fields[1])
	        addresss(fields[2])
	 		city(fields[3])
			state(fields[4])
			zipcode(fields[5])
	      }
	   }
	}
}

class SmartCsvParser{
	static String[] smartSplit(String self){
		def list = []
		def st = new StringTokenizer(self, ",")		
		while(st.hasMoreTokens()){
			def thisToken = st.nextToken()
			while(thisToken.startsWith("\"") && !thisToken.endsWith("\"") ){
				thisToken += "," + st.nextToken()
			}
			list << thisToken.noQuote()
		}
		return list
	}	
	
	static String noQuote(String self){
		if(self.startsWith("\"") || self.startsWith("\'")){ 
			return self[1..-2]
		}
		else{ 
			return self 
		}
	}	
}