/***
 * Excerpted from "Groovy Recipes",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/sdgrvr for more book information.
***/
def xml = """
<person id="99">
  <firstname>Scott</firstname>
  <lastname>Davis</lastname>
</person>	
"""

// XmlParser returns the root node 
def person = new XmlParser().parseText(xml)
//println person
println person.firstname.text()


def contactXml = """<contact>
  <address>
    <street>123 Main St</street>
    <city>Denver</city>
    <state>CO</state>
  </address>
</contact>
"""

def contact = new XmlParser().parseText(contactXml)
//println contact
println contact.address.city[0].text()
//println contact.address.city.text()
//===> Denver





def p0_xml = "<person />"
def p0 = new XmlParser().parseText(p0_xml)

println p0.class
//===> class groovy.util.Node

println p0.attributes().getClass()
//===> class java.util.HashMap

println p0.value().class
println p0.children().class
//===> class java.util.ArrayList

println p0.attributes().size()
println p0.children().size()

println p0.text()
println p0.text().class





def pXml = "<person>Scott</person>"
def p = new XmlParser().parseText(pXml)
println p
println p.class
println p.text()
println p.text().size()
println p.value()
println p.value().size()
println p.children()
println p.children().size()

