/***
 * Excerpted from "Groovy Recipes",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/sdgrvr for more book information.
***/
def xml = """
<person id="99" ssn="555-11-2222">
  <firstname>Scott</firstname>
  <firstname>Bubba</firstname>
  <lastname>Davis</lastname>
</person>	
"""

def person = new XmlParser().parseText(xml)
println person.class
//===> class groovy.util.Node

println person.attributes().getClass()
//===> class java.util.HashMap

println person.value().class
//===> class java.util.ArrayList

println person
//===>
//person[attributes={ssn=555-11-2222, id=99}; value=[firstname[attributes={}; value=[Scott]], lastname[attributes={}; value=[Davis]]]]

println person.name()
//===> person

println person.attributes()
//===> ["ssn":"555-11-2222", "id":"99"]
println person.attribute("id")
println person['@id']
println person.'@id'
//===> 99

println person.value()
//===> [firstname[attributes={}; value=[Scott]], lastname[attributes={}; value=[Davis]]]
println "xxxxx"
println person.value().class
// class java.util.ArrayList

println person.children()
//===> [firstname[attributes={}; value=[Scott]], lastname[attributes={}; value=[Davis]]]
println person.children().class
// class java.util.ArrayList



person.children().each{child->
	println child.name() + ": " + child.text()
}
/*
===>
firstname: Scott
lastname: Davis
*/

println person.get("firstname").text()
println person['firstname'].text()
println person.firstname.text()
//===> Scott

println person.firstname
//===> [firstname[attributes={}; value=[Scott]]]
//println person.firstname.value()
//println person.firstname.children()

println person.firstname.class
//class groovy.util.NodeList
println person['firstname'].class

// 
person.firstname.each{ println it.class}
//class groovy.util.Node
//class groovy.util.Node


def fn1 = person.firstname[0]
println fn1
//firstname[attributes={}; value=[Scott]]
