/***
 * Excerpted from "Groovy Recipes",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/sdgrvr for more book information.
***/
def p = """
<person id="99">
  <fullname>Scott Davis</fullname>
</person>"""

// XmlParser (*** same ***)
def person = new XmlParser().parseText(p)
println person["fullname"].text()
//===> Scott Davis

// XmlSlurper (*** same ***)
person = new XmlParser().parseText(p)
println person["fullname"].text()
//===> Scott Davis




/*
def p = """<person id="99">Scott Davis</person>"""

// XmlParser
def person = new XmlParser().parseText(p)
println person
//===> person[attributes={id=99}; value=[Scott Davis]]

*/




/*
def p = """<person id="99" ssn="555-11-2222">Scott Davis</person>"""
def atts = ["id", "ssn"]

// XmlParser
def person = new XmlParser().parseText(p)
atts.each{att->
  println person["@${att}"]
}
//===>
//99
//555-11-2222

// XmlSlurper
person = new XmlSlurper().parseText(p)
atts.each{att->
  println person["@${att}"]
}
//===>
//99
//555-11-2222

println person."@${atts[0]}"

*/
/*
// XmlParser
def person = new XmlParser().parseText(p)
println person.attributes()
//===> ["ssn":"555-11-2222", "id":"99"]
person.attributes().each{name, value->
  println "${name} ${value}"
}
//===>
//ssn 555-11-2222
//id 99

println person.attribute("id")
//===> 99

// XmlSlurper
person = new XmlSlurper().parseText(p)
println person.attributes()
//===> ["ssn":"555-11-2222", "id":"99"]
println person.@id
//===> 99

*/



/*
// XmlParser
def person = new XmlParser().parseText(p)
println person.getClass()
//===> class groovy.util.Node

// XmlSlurper
person = new XmlSlurper().parseText(p)
println person.getClass()
//===> class groovy.util.slurpersupport.NodeChild




// XmlParser
//def p = """<person id="99">Scott Davis</person>"""
person = new XmlParser().parseText(p)
println person.text()
//===> Scott Davis
println person.attribute("id")
//===> 99
println person.attribute("foo")
//===> null


println person.children()
//===> ["Scott Davis"]
println person.attributes()
//===> ["id":"99"]




// XmlSlurper
person = new XmlSlurper().parseText(p)
println person
//===> Scott Davis
println person.@id
//===> 99
println person.@foo






// XmlParser
//def p = """<person id="99">Scott Davis</person>"""
person = new XmlParser().parseText(p)
println person.text()
//===> Scott Davis

// XmlSlurper
person = new XmlSlurper().parseText(p)
println person.text()
println person
//===> Scott Davis

*/


/*
println "############ XmlParser"
def person = new XmlParser().parseText(p)
println person.class
//class groovy.util.Node
println person
//person[attributes={id=99}; value=[]]
println person.text()
//Scott Davis
println person.'@id'
println person['@id']
//99
println person.attributes().getClass()
//class java.util.HashMap
println person.attributes()
//["id":"99"]

println "############ XmlSlurper"
person = new XmlSlurper().parseText(p)
println person.class
//(nothing -- thinks that this is gpath navigation)
println person.getClass()
//class groovy.util.slurpersupport.NodeChild
println person
//Scott Davis
println person.text()
//Scott Davis

println person.'@id'
println person['@id']
println person.@id
//99
println person.attributes().getClass()
//class java.util.HashMap
println person.attributes()
//["id":"99"]
*/