/***
 * Excerpted from "Groovy Recipes",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/sdgrvr for more book information.
***/

def p = """
<person id="99">
  <firstname>Scott</firstname>
  <lastname>Davis</lastname>
  <address type="home">
    <street>123 Main St</street>
    <city>Denver</city>
    <state>CO</state>
    <zip>80020</zip>
  </address>
  <address type="work">
    <street>987 Other Ave</street>
    <city>Boulder</city>
    <state>CO</state>
    <zip>80090</zip>
  </address>
</person>"""

def person = new XmlSlurper().parseText(p)

println person.address.city
//===>DenverBoulder

println person.address[0].city
//===>Denver

println "each"
person.address.city.each{println it}


/*
def p = """
<person id="99">
  <firstname>Scott</firstname>
  <lastname>Davis</lastname>
  <address type="home">
    <street>123 Main St</street>
    <city>Denver</city>
    <state>CO</state>
    <zip>80020</zip>
  </address>
</person>"""

def person = new XmlSlurper().parseText(p)
println person.firstname
//===> Scott
println person.lastname
//===> Davis
println person.address.city
//===> Denver


println person
//===> ScottDavis123 Main StDenverCO80020
println person.address
//===> 123 Main StDenverCO80020


println person.firstname
//===> Scott

println person.lastname
//===> Davis

println person.address.city
//===> Denver
*/







//def list = person.address.children().list()
//println list.join(", ")


//println list.getClass().methods.each{println it}

/*def p = """
<person id="99">
  <firstname>Scott</firstname>
  <lastname>Davis</lastname>
  <address type="home">
    <street>123 Main St</street>
    <city>Denver</city>
    <state>CO</state>
    <zip>80020</zip>
  </address>
  <address type="work">
    <street>987 Other Ave</street>
    <city>Boulder</city>
    <state>CO</state>
    <zip>80090</zip>
  </address>
</person>"""

def person = new XmlParser().parseText(p)

println person.address[0].attribute("type")
//===> home
println person.address[1].attribute("type")
//===> work
person.address.each{a->
  println a.attribute("type")
}
//===>
//home
//work


person.address.each{a->
  println a.city[0].text()
}
//===>
//Denver
//Boulder

person.address.city.each{c->
  println c.text()
}
//===>
//Denver
//Boulder




person.address.each{a->
  println a.attribute("type")
}
//===>
//home
//work
*/


/*
def p = """
<person id="99">
  <firstname>Scott</firstname>
  <lastname>Davis</lastname>
  <address type="home">
    <street>123 Main St</street>
    <city>Denver</city>
    <state>CO</state>
    <zip>80020</zip>
  </address>
</person>"""

// XmlParser
def person = new XmlParser().parseText(p)
println person.firstname.text()
//===> Scott

println "text"
println person.text()
// empty string

if(person.text()){
	println "Leaf"
} else{
	println "Branch"
}

if(person.children()){
	println "Branch"	
} else{
	println "Leaf"	
}


println "children"
println person.children()
//[
//firstname[attributes={}; value=[Scott]], 
//lastname[attributes={}; value=[Davis]], 
//address[attributes={type=home}; value=[
//  street[attributes={}; value=[123 Main St]], 
//  city[attributes={}; value=[Denver]], 
//  state[attributes={}; value=[CO]], 
//  zip[attributes={}; value=[80020]]
//]]
//]
////
//

*/
//println person.address.street.text()
//Caught: groovy.lang.MissingMethodException: 
// No signature of method: java.util.ArrayList.text() 
// is applicable for argument types: () values: {}

//technically, getting ArrayLists that have a single Node 
//[firstname[attributes={}; value=[Scott]]]
//[street[attributes={}; value=[123 Main St]]]

/*
println person.firstname[0].text()
//===> Scott

println person.address[0].street[0].text()
//===> 123 Main St



// XmlSlurper
person = new XmlSlurper().parseText(p)
println person.firstname
//===> Scott

println person.address.street
//===> 123 Main St
*/



/*
def p = """
<person id="99">
  <firstname>Scott</firstname>
</person>"""
def person = new XmlParser().parseText(p)
println person.firstname.text()


def p2 = """
<person id="99">
  <firstname>Billy</firstname>
  <firstname>Bob</firstname>
</person>"""
def person2 = new XmlParser().parseText(p2)
println person2.firstname.text()

*/