/***
 * Excerpted from "Groovy Recipes",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/sdgrvr for more book information.
***/
def p = """<person id="99">Scott Davis</person>"""
def person =  new XmlSlurper().parseText(p)
println person
//===> Scott Davis
println person.@id
//===> 99

def p2 = """
<person id="99">
  <firstname>Scott</firstname>
  <lastname>Davis</lastname>
  <address type="home">
    <street>123 Main St</street>
    <city>Denver</city>
    <state>CO</state>
    <zip>80020</zip>
  </address>
</person>"""

def person2 = new XmlSlurper().parseText(p2)
println person2.firstname
//===> Scott 

println person2.address.city
//===> Denver

println person2.address.@type
//===> home


//hashmap syntax
println person2['firstname']


//mixed case
def p3 = """
<person id="99">
  <firstname>Scott</firstname>
  <LastName>Davis</LastName>
</person>"""
def person3 = new XmlSlurper().parseText(p3)
println person3.firstname
//===> Scott
println person3.LastName
//===> Davis
println "asking for a node that doesn't exist:"
println person3.foo


//hyphens
def p4 = """
<person id="99">
  <first-name>Scott</first-name>
  <last_name>Davis</last_name>
</person>	
"""

def person4 = new XmlSlurper().parseText(p4)
println person4.'first-name'
println person4['first-name']
//===> Scott
println person4.last_name
println person4.'last_name'
println person4['last_name']
//===> Davis


//namespaces
def itemXml = """
<item 
  xmlns:product="urn:somecompany:products"
  xmlns:vendor="urn:somecompany:vendors">
    <product:name>iPhone</product:name>
    <vendor:name>Apple</vendor:name>
    <quantity>1</quantity>
</item>
"""

def item = new XmlSlurper().parseText(itemXml)
println item.name
//===> iPhoneApple

def ns = [:]
ns.product = "urn:somecompany:products"
ns.vendor = "urn:somecompany:vendors" 
item.declareNamespace(ns) 

println item.'product:name'
//===> iPhone


