/***
 * Excerpted from "Groovy Recipes",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/sdgrvr for more book information.
***/
def xml = """
<person id="99">
  <firstname>Scott</firstname>
  <LastName>Davis</LastName>
</person>	
"""
def person = new XmlSlurper().parseText(xml)

println person.'@id'
println person['@id']
println person.@id

println person.firstname
println person['firstname']

println person.LastName
println person['LastName']


def itemXml = """
<item 
  xmlns:product="urn:somecompany:products"
  xmlns:vendor="urn:somecompany:vendors">
    <product:name>iPhone</product:name>
    <vendor:name>Apple</vendor:name>
    <quantity>1</quantity>
</item>
"""

def item = new XmlSlurper().parseText(itemXml)
println item.name
//===> iPhoneApple

def ns = [:]
ns.product = "urn:somecompany:products"
ns.vendor = "urn:somecompany:vendors" 
item.declareNamespace(ns) 

println item.'product:name'
//===> iPhone