/***
 * Excerpted from "Groovy Recipes",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/sdgrvr for more book information.
***/
def xml = """
<person>
  <firstname>Scott</firstname>
  <lastname>Davis</lastname>
</person>	
"""

class Person{
  String firstname
  String lastname
}

def pxml = new XmlParser().parseText(xml)
def person = new Person()

pxml.children().each{child ->
  person.setProperty(child.name(), child.value())	
}

println "xml:"
println xml
println "person:"
println person.properties

def out = toXml(person)
println ""
println "out:"
println out


def String toXml(pogo){
	def longName = pogo.class.toString()
	def name = longName.tokenize(" ")[1]
	def personOut = new groovy.xml.StreamingMarkupBuilder().bind{
		unescaped << "<${name}>"
		pogo.properties.each{key, value->
			out << key("test")
		}

		unescaped << "</${name}>"	
	}
    return personOut

}

